<script setup lang="ts">
import type { Product } from '@/types/Product'
import { type ReceiptItem } from '@/types/ReceiptItem'
import { nextTick, onMounted, ref } from 'vue'

import { provide } from 'vue'
import { useReceiptStore } from '@/stores/receipt'
import { useMemberStore } from '@/stores/member'

import ProductList from '@/components/ProductList.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import ReceiptCard from './ReceiptCard.vue'
import AddMemberDialog from './AddMemberDialog.vue'
import MemberCard from './MemberCard.vue'
import paymentTypeDialog from './PaymentType.vue'
import PaymentView from './PaymentView.vue'
import { useProductStore } from '@/stores/product'
import { usePosStore } from '@/stores/pos'
import { useRouter } from 'vue-router'

const router = useRouter()

const navigateToPaymentView = () => {
  router.push('/pos/paymentView')
}
const product = ref<Product>()
const receiptStore = useReceiptStore()
const memberStore = useMemberStore()
const productStore = useProductStore()
const posStore = usePosStore()

const tab = ref(1)
const selectTab = (tabNumber: number) => {
  tab.value = tabNumber
}

const divReceiptItems = ref<HTMLElement | null>(null)
const selected = (p: Product) => {
  if (!p.id) return
  product.value = p
  const newReceiptItem: ReceiptItem = {
    id: -1,
    name: p.name,
    price: p.price,
    unit: 1,
    productId: p.id,
    sweet: receiptStore.sweet,
    type: receiptStore.type,
    size: receiptStore.size
  }
  receiptStore.addReceiptItem(newReceiptItem)
  nextTick(() => {
    if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
  })
}

onMounted(async () => {
  await posStore.getProducts()
})
</script>

<template>
  <v-row>
    <v-col cols="12" sm="6" md="6">
      <v-container style="padding: 0">
        <v-row>
          <v-col cols="12">
            <v-sheet min-width="300" max-width="790" height="625" elevation="6" style="background-color: #dec6ae"
              class="mt-3">
              <v-row justify="center" class="mb-0 mr-3 ml-3">
                <v-col cols="4">
                  <v-btn @click="selectTab(1)" elevation="4" size="large" prepend-icon="mdi-coffee" block
                    rounded="xl">Drinks</v-btn>
                </v-col>
                <v-col cols="4">
                  <v-btn @click="selectTab(2)" elevation="4" size="large" prepend-icon="mdi-bread-slice" block
                    rounded="xl">Bakery</v-btn>
                </v-col>
                <v-col cols="4">
                  <v-btn @click="selectTab(3)" elevation="4" size="large" prepend-icon="mdi-food" block
                    rounded="xl">Food</v-btn>
                </v-col>
              </v-row>

              <v-window v-model="tab">
                <v-window-item :value="1">
                  <ProductList :products="posStore.drinkProducts" @selected-product="selected"></ProductList>
                </v-window-item>
                <v-window-item :value="2">
                  <ProductList :products="posStore.bakeryProducts" @selected-product="selected"></ProductList>
                </v-window-item>
                <v-window-item :value="3">
                  <ProductList :products="posStore.foodProducts" @selected-product="selected"></ProductList>
                </v-window-item>
              </v-window>
            </v-sheet>
          </v-col>
        </v-row>
      </v-container>
    </v-col>
    <v-col cols="12" sm="6" md="6">
      <v-container style="padding: 0">
        <v-row>
          <v-col cols="12">
            <div ref="divReceiptItems" style="height: 600; overflow: auto">
              <v-sheet min-width="300" max-width="790" height="450" elevation="6">
                <!-- ตารางแสดงรายละเอียดสินค้า -->
                <ReceiptDetailTable></ReceiptDetailTable>
              </v-sheet>
            </div>
          </v-col>

          <v-col cols="12">
            <v-sheet class="d-flex justify-center align-center" style="background-color: #dec6ae; color: #412f26"
              rounded min-width="300" max-width="790" height="150" elevation="6">
              <!-- ปุ่ม -->
              <v-container>
                <v-row>
                  <v-col cols="8" class="pl-0">
                    <span class="font-weight-bold text-uppercase">จำนวนสุทธิ :</span>
                    <span class="font-weight-bold"> {{ receiptStore.receipt!.qty }}</span>
                  </v-col>
                </v-row>
                <!-- เว้นบรรทัด -->
                <v-row>
                  <v-col cols="6">
                    <v-btn class="align-right" variant="plain" elevation="4" size="large" prepend-icon="mdi-close-thick"
                      block rounded="xl" @click="() => {
                      receiptStore.clear()
                      memberStore.clearFrom()
                    }
                    ">ยกเลิก</v-btn>
                  </v-col>
                  <v-col cols="6">
                    <v-btn class="align-right" variant="plain" elevation="4" size="large"
                      prepend-icon="mdi-credit-card-outline" block rounded="xl"
                      @click="navigateToPaymentView">ชำระเงิน</v-btn>
                  </v-col>
                </v-row>
              </v-container>
            </v-sheet>
          </v-col>
        </v-row>
      </v-container>
    </v-col>
  </v-row>
  <!-- </v-container> -->
</template>

<style scoped>
.v-card {
  text-align: center;
  border: 2px solid;
  font-family: 'Franklin Gothic Medium', 'Arial Narrow', Arial, sans-serif;
  font-size: 70px;
  color: #412f26;
}

.v-sheet,
.v-card {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
